// File autogenerated

#if !defined(ACCESSPOINTPROXY_H_INCLUDED)
#define ACCESSPOINTPROXY_H_INCLUDED

// Qt includes
#include <qobject.h>

// forward declarations
class QDBusConnection;
class QDBusDataList;
class QDBusError;
class QDBusMessage;
class QDBusProxy;
class QDBusVariant;
class QString;
template <typename K, typename V> class QMap;
template <typename T> class QValueList;

namespace DBus
{

class AccessPointProxy : public QObject
{
    Q_OBJECT
public:
    AccessPointProxy(const QString& service, const QString& path, QObject* parent = 0, const char* name = 0);

    virtual ~AccessPointProxy();

    void setConnection(const QDBusConnection& connection);

signals:
    void PropertiesChanged(const QMap<QString, QDBusVariant>& properties);


public:
    virtual void setDBusProperty(const QString& name, const QDBusVariant& variant, QDBusError& error);
    virtual QDBusVariant getDBusProperty(const QString& name, QDBusError& error) const;

    virtual Q_UINT32 getFlags(QDBusError& error) const;

    virtual Q_UINT32 getWpaFlags(QDBusError& error) const;

    virtual Q_UINT32 getRsnFlags(QDBusError& error) const;

    virtual QValueList<Q_UINT8> getSsid(QDBusError& error) const;

    virtual Q_UINT32 getFrequency(QDBusError& error) const;

    virtual QString getHwAddress(QDBusError& error) const;

    virtual Q_UINT32 getMode(QDBusError& error) const;

    virtual Q_UINT32 getMaxBitrate(QDBusError& error) const;

    virtual Q_UINT8 getStrength(QDBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const QDBusMessage& message);

protected:
    QDBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    AccessPointProxy(const AccessPointProxy&);
    AccessPointProxy& operator=(const AccessPointProxy&);
}; // class AccessPointProxy

}; // namespace DBus

#endif //ACCESSPOINTPROXY_H_INCLUDED

// End of File

