// File autogenerated

// declaration include
#include "activeconnectionproxy.h"

// Qt includes
#include <qmap.h>
#include <qstring.h>
#include <qvaluelist.h>

// Qt D-Bus includes
#include <dbus/qdbusconnection.h>
#include <dbus/qdbusdata.h>
#include <dbus/qdbusdatalist.h>
#include <dbus/qdbusdatamap.h>
#include <dbus/qdbuserror.h>
#include <dbus/qdbusmessage.h>
#include <dbus/qdbusobjectpath.h>
#include <dbus/qdbusproxy.h>
#include <dbus/qdbusvariant.h>


namespace DBus
{

ActiveConnectionProxy::ActiveConnectionProxy(const QString& service, const QString& path, QObject* parent, const char* name)
    : QObject(parent, name),
      m_baseProxy(new QDBusProxy())
{
    m_baseProxy->setInterface("org.freedesktop.NetworkManager.Connection.Active");
    m_baseProxy->setPath(path);
    m_baseProxy->setService(service);

    QObject::connect(m_baseProxy, SIGNAL(dbusSignal(const QDBusMessage&)),
                     this,        SLOT(slotHandleDBusSignal(const QDBusMessage&)));
}

ActiveConnectionProxy::~ActiveConnectionProxy()
{
    delete m_baseProxy;
}

void ActiveConnectionProxy::setConnection(const QDBusConnection& connection)
{
    m_baseProxy->setConnection(connection);
}

void ActiveConnectionProxy::setDBusProperty(const QString& name, const QDBusVariant& value, QDBusError& error)
{
    QDBusConnection connection = m_baseProxy->connection();

    QDBusMessage message = QDBusMessage::methodCall(m_baseProxy->service(), m_baseProxy->path(), "org.freedesktop.DBus.Properties", "Set");

    message << QDBusData::fromString(m_baseProxy->interface());
    message << QDBusData::fromString(name);
    message << QDBusData::fromVariant(value);

    connection.sendWithReply(message, &error);
}

QDBusVariant ActiveConnectionProxy::getDBusProperty(const QString& name, QDBusError& error) const
{
    QDBusConnection connection = m_baseProxy->connection();

    QDBusMessage message = QDBusMessage::methodCall(m_baseProxy->service(), m_baseProxy->path(), "org.freedesktop.DBus.Properties", "Get");

    message << QDBusData::fromString(m_baseProxy->interface());
    message << QDBusData::fromString(name);

    QDBusMessage reply = connection.sendWithReply(message, &error);

    if (reply.type() != QDBusMessage::ReplyMessage) return QDBusVariant();
    if (reply.count() != 1) return QDBusVariant();

    bool ok = false;
    QDBusVariant value = reply.front().toVariant(&ok);
    if (!ok) return QDBusVariant();

    return value;
}

QString ActiveConnectionProxy::getServiceName(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("ServiceName", error);

    if (error.isValid()) return QString();

    bool ok = false;

    QString result =  variant.value.toString(&ok);
    if (!ok) {}

    return result;
}

QDBusObjectPath ActiveConnectionProxy::getConnection(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("Connection", error);

    if (error.isValid()) return QDBusObjectPath();

    bool ok = false;

    QDBusObjectPath result =  variant.value.toObjectPath(&ok);
    if (!ok) {}

    return result;
}

QDBusObjectPath ActiveConnectionProxy::getSpecificObject(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("SpecificObject", error);

    if (error.isValid()) return QDBusObjectPath();

    bool ok = false;

    QDBusObjectPath result =  variant.value.toObjectPath(&ok);
    if (!ok) {}

    return result;
}

QString ActiveConnectionProxy::getSharedServiceName(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("SharedServiceName", error);

    if (error.isValid()) return QString();

    bool ok = false;

    QString result =  variant.value.toString(&ok);
    if (!ok) {}

    return result;
}

QDBusObjectPath ActiveConnectionProxy::getSharedConnection(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("SharedConnection", error);

    if (error.isValid()) return QDBusObjectPath();

    bool ok = false;

    QDBusObjectPath result =  variant.value.toObjectPath(&ok);
    if (!ok) {}

    return result;
}

QValueList<QDBusObjectPath> ActiveConnectionProxy::getDevices(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("Devices", error);

    if (error.isValid()) return QValueList<QDBusObjectPath>();

    bool ok = false;

    bool subOK = false;

    QValueList<QDBusObjectPath> result =  variant.value.toList(&ok).toObjectPathList(&subOK);
    if (!subOK) {}
    if (!ok) {}

    return result;
}

Q_UINT32 ActiveConnectionProxy::getState(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("State", error);

    if (error.isValid()) return Q_UINT32();

    bool ok = false;

    Q_UINT32 result =  variant.value.toUInt32(&ok);
    if (!ok) {}

    return result;
}

bool ActiveConnectionProxy::getDefault(QDBusError& error) const
{
    QDBusVariant variant = getDBusProperty("Default", error);

    if (error.isValid()) return bool();

    bool ok = false;

    bool result =  variant.value.toBool(&ok);
    if (!ok) {}

    return result;
}

void ActiveConnectionProxy::slotHandleDBusSignal(const QDBusMessage& message)
{
    if (message.member() == "PropertiesChanged")
    {
        QMap<QString, QDBusVariant> _properties = message[0].toStringKeyMap().toVariantMap();

        emit PropertiesChanged(_properties);
    }
}

}; // namespace DBus

// End of File

