// File autogenerated

#if !defined(ACTIVECONNECTIONPROXY_H_INCLUDED)
#define ACTIVECONNECTIONPROXY_H_INCLUDED

// Qt includes
#include <qobject.h>

// forward declarations
class QDBusConnection;
class QDBusDataList;
class QDBusError;
class QDBusMessage;
class QDBusObjectPath;
class QDBusProxy;
class QDBusVariant;
class QString;
template <typename K, typename V> class QMap;
template <typename T> class QValueList;

namespace DBus
{

class ActiveConnectionProxy : public QObject
{
    Q_OBJECT
public:
    ActiveConnectionProxy(const QString& service, const QString& path, QObject* parent = 0, const char* name = 0);

    virtual ~ActiveConnectionProxy();

    void setConnection(const QDBusConnection& connection);

signals:
    void PropertiesChanged(const QMap<QString, QDBusVariant>& properties);


public:
    virtual void setDBusProperty(const QString& name, const QDBusVariant& variant, QDBusError& error);
    virtual QDBusVariant getDBusProperty(const QString& name, QDBusError& error) const;

    virtual QString getServiceName(QDBusError& error) const;

    virtual QDBusObjectPath getConnection(QDBusError& error) const;

    virtual QDBusObjectPath getSpecificObject(QDBusError& error) const;

    virtual QString getSharedServiceName(QDBusError& error) const;

    virtual QDBusObjectPath getSharedConnection(QDBusError& error) const;

    virtual QValueList<QDBusObjectPath> getDevices(QDBusError& error) const;

    virtual Q_UINT32 getState(QDBusError& error) const;

    virtual bool getDefault(QDBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const QDBusMessage& message);

protected:
    QDBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    ActiveConnectionProxy(const ActiveConnectionProxy&);
    ActiveConnectionProxy& operator=(const ActiveConnectionProxy&);
}; // class ActiveConnectionProxy

}; // namespace DBus

#endif //ACTIVECONNECTIONPROXY_H_INCLUDED

// End of File

