// File autogenerated

// declaration include
#include "cdmaproxy.h"

// Qt includes
#include <qmap.h>
#include <qstring.h>

// Qt D-Bus includes
#include <dbus/qdbusdata.h>
#include <dbus/qdbusdatamap.h>
#include <dbus/qdbuserror.h>
#include <dbus/qdbusmessage.h>
#include <dbus/qdbusproxy.h>
#include <dbus/qdbusvariant.h>


namespace DBus
{

CDMADeviceProxy::CDMADeviceProxy(const QString& service, const QString& path, QObject* parent, const char* name)
    : QObject(parent, name),
      m_baseProxy(new QDBusProxy())
{
    m_baseProxy->setInterface("org.freedesktop.NetworkManager.Device.Cdma");
    m_baseProxy->setPath(path);
    m_baseProxy->setService(service);

    QObject::connect(m_baseProxy, SIGNAL(dbusSignal(const QDBusMessage&)),
                     this,        SLOT(slotHandleDBusSignal(const QDBusMessage&)));
}

CDMADeviceProxy::~CDMADeviceProxy()
{
    delete m_baseProxy;
}

void CDMADeviceProxy::setConnection(const QDBusConnection& connection)
{
    m_baseProxy->setConnection(connection);
}

void CDMADeviceProxy::slotHandleDBusSignal(const QDBusMessage& message)
{
    if (message.member() == "PropertiesChanged")
    {
        QMap<QString, QDBusVariant> _properties = message[0].toStringKeyMap().toVariantMap();

        emit PropertiesChanged(_properties);
    }
}

}; // namespace DBus

// End of File

