// File autogenerated

#if !defined(DEVICEPROXY_H_INCLUDED)
#define DEVICEPROXY_H_INCLUDED

// Qt includes
#include <qobject.h>

// forward declarations
class QDBusConnection;
class QDBusError;
class QDBusMessage;
class QDBusObjectPath;
class QDBusProxy;
class QDBusVariant;
class QString;

namespace DBus
{

class DeviceProxy : public QObject
{
    Q_OBJECT
public:
    DeviceProxy(const QString& service, const QString& path, QObject* parent = 0, const char* name = 0);

    virtual ~DeviceProxy();

    void setConnection(const QDBusConnection& connection);

signals:
    void StateChanged(Q_UINT32 state);


public:
    virtual void setDBusProperty(const QString& name, const QDBusVariant& variant, QDBusError& error);
    virtual QDBusVariant getDBusProperty(const QString& name, QDBusError& error) const;

    virtual QString getUdi(QDBusError& error) const;

    virtual QString getInterface(QDBusError& error) const;

    virtual QString getDriver(QDBusError& error) const;

    virtual Q_UINT32 getCapabilities(QDBusError& error) const;

    virtual Q_INT32 getIp4Address(QDBusError& error) const;

    virtual Q_UINT32 getState(QDBusError& error) const;

    virtual QDBusObjectPath getIp4Config(QDBusError& error) const;

    virtual bool getManaged(QDBusError& error) const;

    virtual Q_UINT32 getDeviceType(QDBusError& error) const;

protected slots: // usually no need to reimplement
    virtual void slotHandleDBusSignal(const QDBusMessage& message);

protected:
    QDBusProxy* m_baseProxy;

private: // Hiding copy constructor and assignment operator
    DeviceProxy(const DeviceProxy&);
    DeviceProxy& operator=(const DeviceProxy&);
}; // class DeviceProxy

}; // namespace DBus

#endif //DEVICEPROXY_H_INCLUDED

// End of File

